<!DOCTYPE html>
<html lang="en">
<head>
  <%- include('partials/head.ejs'); -%>
</head>
<body>
<div class="container bg-3">

  <%- include('partials/header.ejs'); -%>

  <div class="row main-container">

  <div class="row text-right">
    <button class="btn add-btn" data-toggle="modal" data-target="#createMedicine" ><i class="fa fa-folder"></i> Add Medicine</button>
  </div>
        <div class="row">
          <div class="col-sm-6 col-sm-offset-3">
            <div class="row">
              <div class="col-sm-12">
                <% if(error){ %>
                  <div class="alert alert-danger"><%= error %></div>
              <% } %>
              </div>
            </div>
          </div><!--/col-sm-6-->
        </div><!--/row-->
        <% if(medicines == "Medicines not found"){ %>
            <h4>Medicines not found.</h4>
        <% }else{ %>
        <div class="mt-2" style="background-color: rgb(255, 255, 255)">
          <div class="row">
            <div class="col">
              <div class="table-responsive mt-5">
                <table class="table table-bordered table-striped table-hover users-table mb-2">
                  <thead>
                    <tr>
                      <th>Name</th>
                      <th>Salt</th>
                      <th>Brand</th>
                      <th>Cost</th>
                      <th>Description</th>
                      <th>Image</th>
                      <th class="no-sort">Actions</th>
                    </tr>
                  </thead>
                  <tbody>
                    <% medicines.forEach(function(medicine, medicineIndex){  %>
                    <tr>
                        <td><%= medicine.name %></td>
                        <td><%= medicine.sale %></td>
                        <td><%= medicine.brand %></td>
                        <td><%= medicine.cost %></td>
                        <td><%= medicine.description %></td>
                        <td>
                          <% if(medicine.image && medicine.image !=""){ %>
                              <img src="/<%= medicine.image %>" height="100" width="100"/>
                          <% } %>
                        </td>
                        <td>
                          <button class="btn" data-toggle="modal" data-target="#upadteMedicine_<%= medicine._id %>" ><i class="fa fa-edit"></i></button>
                          <button class="btn deleteMedicine" data-id="<%= medicine._id %>"><i class="fa fa-trash"></i></button>
                        </td>
                    </tr>
                    <!-- Update Modal -->
                        <div class="modal fade" id="upadteMedicine_<%= medicine._id %>" role="dialog">
                          <div class="modal-dialog">
                                          <!-- Modal content-->
                           <div class="modal-content">
                             <div class="modal-header">
                               <button type="button" class="close" data-dismiss="modal">&times;</button>
                               <h4 class="modal-title">Update Medicine</h4>
                             </div>
                             <div class="modal-body">
                               <div class="alert alert-success successUpdateMedicine_<%= medicine._id %>" style="display:none"> </div>
                               <div class="alert alert-danger errorUpdateMedicine_<%= medicine._id %>" style="display:none"> </div>

                               <form id="uploadForm_<%= medicine._id %>" data-id="<%= medicine._id %>" class="uploadForm" enctype="multipart/form-data" method="POST">
                                 <div class="form-group col-md-6">
                                    <label for="name_<%= medicine._id %>">Medicine Name</label>
                                    <input type="text" class="input-lg form-control" name="name" id="name_<%= medicine._id %>" placeholder="Medicine name" required value="<%= medicine.name %>">
                                  </div>
                                  <div class="form-group col-md-6">
                                    <label for="salt_<%= medicine._id %>">Salt</label>
                                    <input type="text" class="input-lg form-control" name="salt" id="salt_<%= medicine._id %>" placeholder="Salt" value="<%= medicine.salt %>">
                                  </div>
                                  <div class="form-group col-md-6">
                                    <label for="brand_<%= medicine._id %>">Brand</label>
                                    <input type="text" class="input-lg form-control" name="brand" id="brand_<%= medicine._id %>" placeholder="Brand" value="<%= medicine.brand %>">
                                  </div>
                                  <div class="form-group col-md-6">
                                     <label for="cost_<%= medicine._id %>">Cost</label>
                                     <input type="number" class="input-lg form-control" name="cost" id="cost_<%= medicine._id %>" placeholder="Cost" value="<%= medicine.cost %>">
                                   </div>
                                   <div class="form-group col-md-6">
                                     <label for="image_<%= medicine._id %>">Image</label>
                                     <input type="file" class="input-lg form-control" name="medicine_image" id="image_<%= medicine._id %>" >
                                   </div>
                                  <div class="form-group col-md-12">
                                    <label for="description_<%= medicine._id %>">Description</label>
                                    <textarea class="form-control" name="description" rows="5" id="description_<%= medicine._id %>"><%= medicine.description %></textarea>
                                  </div>
                                </form>
                             </div>
                             <div class="clearfix"></div>
                             <div class="modal-footer">
                               <button  class="btn updateMedicine" data-id="<%= medicine._id %>" >Update Medicine</button>
                               <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                             </div>
                           </div>

                         </div>
                       </div>
                  <!-- Update Modal -->
                    <% }) %>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
    <% } %>
  </div>
</div>

<%- include('partials/footer.ejs'); -%>
<script>
      $(document).ready(function() {
        $(".users-table").DataTable({
          "aaSorting": [],
          "columnDefs": [ {
            "targets": 'no-sort',
            "orderable": false,
          } ]
        });
        // Create form submit when click on button
        $('#createMedicineButton').click(function() {
          $('#uploadForm').submit()
        });
        // Delete doctor
        $(document).on('click', '.deleteMedicine', function() {
          let medicineID = $(this).data('id')

          swal({
            title: "Are you sure?",
            text: "You want to delete Clinic",
            type: "warning",
            type: "warning",
            showCancelButton: true,
            confirmButtonClass: "btn-danger",
            confirmButtonText: "Yes, delete it!",
            closeOnConfirm: false
          },
          function(){
            $.ajax({
                data:{medicineID:medicineID},
                url:"/medicines/delete",
                type: "DELETE",
                error: function(xhr) {
                },
                success: function(response) {
                    if(response.status == "error"){
                    }else{
                      swal({
                        title: "Deleted",
                        text: "",
                        type: "success",
                        confirmButtonText: "Okay"
                      },
                      function(){
                        location.reload()
                      });
                    }
                }
            });
          });
        });

        // Create form submit
        $('#uploadForm').submit(function(e) {
            e.preventDefault();
            var name = $('#name').val();
            var cost = $('#cost').val();

            if(name == ""){
              $('.errorCreateMedicine').show()
              $('.errorCreatemedicine').html("Medicine name is required")
              setTimeout(function(){ $('.errorCreateMedicine').hide() }, 3000)
              return false
            }

            if(name != "" && cost < 0){
              $('.errorCreateMedicine').show()
              $('.errorCreatemedicine').html("Plase enter a valid cost")
              setTimeout(function(){ $('.errorCreateMedicine').hide() }, 3000)
              return false
            }

            $(this).ajaxSubmit({
                url: "/medicines/create",
                type: "POST",
                error: function(xhr) {
                  $('.errorCreateMedicine').show()
                  $('.errorCreateMedicine').html(xhr.responseJSON.message)
                  setTimeout(function(){ $('.errorCreateMedicine').hide() }, 3000);
                },
                success: function(response) {
                    if(response.status == "error"){
                      $('.errorCreateMedicine').show()
                      $('.errorCreateMedicine').html(response.message)
                      setTimeout(function(){ $('.errorCreateMedicine').hide() }, 3000);
                    }else{
                      $('.successCreateMedicine').show()
                      $('.successCreateMedicine').html(response.message)
                      setTimeout(function(){ location.reload() }, 1000);
                    }
                }
            });
            //Very important line, it disable the page refresh.
            return false;
        });

        // update form submit when click on update button
        $('.updateMedicine').click(function() {
          let medicineID = $(this).data('id')
          $('#uploadForm_'+medicineID).submit()
        });

        // UPDATE form submit
        $('.uploadForm').submit(function(e) {
            e.preventDefault();
            let medicineID = $(this).data('id')

            var name = $('#name_'+medicineID).val();
            var cost = $('#cost_'+medicineID).val();

            if(name == ""){
              $('.errorUpdateMedicine_'+medicineID).show()
              $('.errorUpdateMedicine_'+medicineID).html("Medicine name is required")
              setTimeout(function(){ $('.errorCreateMedicine_'+medicineID).hide() }, 3000)
              return false
            }

            if(name != "" && cost < 0){
              $('.errorUpdateMedicine_'+medicineID).show()
              $('.errorUpdateMedicine_'+medicineID).html("Plase enter a valid cost")
              setTimeout(function(){ $('.errorCreateMedicine_'+medicineID).hide() }, 3000)
              return false
            }

            $(this).ajaxSubmit({
                url: "/medicines/update?medicineID="+medicineID,
                error: function(xhr) {
                  $('.errorUpdateMedicine_'+medicineID).show()
                  $('.errorUpdateMedicine_'+medicineID).html(xhr.responseJSON.message)
                  setTimeout(function(){ $('.errorUpdateMedicine_'+medicineID).hide() }, 3000);
                },
                success: function(response) {
                    if(response.status == "error"){
                      $('.errorUpdateMedicine_'+medicineID).show()
                      $('.errorUpdateMedicine_'+medicineID).html(response.message)
                      setTimeout(function(){ $('.errorUpdateMedicine_'+medicineID).hide() }, 3000);
                    }else{
                      $('.successUpdateMedicine_'+medicineID).show()
                      $('.successUpdateMedicine_'+medicineID).html(response.message)
                      setTimeout(function(){ location.reload() }, 1000);
                    }
                }
            });
            //Very important line, it disable the page refresh.
            return false;
        });

      });
</script>

<!-- Create Modal -->
    <div class="modal fade" id="createMedicine" role="dialog">
      <div class="modal-dialog">
                      <!-- Modal content-->
       <div class="modal-content">
         <div class="modal-header">
           <button type="button" class="close" data-dismiss="modal">&times;</button>
           <h4 class="modal-title">Create Medicine</h4>
         </div>
         <div class="modal-body">
           <div class="alert alert-success successCreateMedicine" style="display:none"> </div>
           <div class="alert alert-danger errorUpdateMedicine" style="display:none"> </div>

           <form id="uploadForm" enctype="multipart/form-data" action="/medicines/create" method="post">
              <div class="form-group col-md-6">
                 <label for="name">Medicine Name</label>
                 <input type="text" class="input-lg form-control" name="name" id="name" placeholder="Medicine name" required>
               </div>
               <div class="form-group col-md-6">
                 <label for="salt">Salt</label>
                 <input type="text" class="input-lg form-control" name="salt" id="salt" placeholder="Salt" required>
               </div>
               <div class="form-group col-md-6">
                 <label for="brand">Brand</label>
                 <input type="text" class="input-lg form-control" name="brand" id="brand" placeholder="Brand" required>
               </div>
               <div class="form-group col-md-6">
                  <label for="cost">Cost</label>
                  <input type="number" class="input-lg form-control" name="cost" id="cost" placeholder="Cost" >
                </div>
                <div class="form-group col-md-6">
                  <label for="image">Image</label>
                  <input type="file" class="input-lg form-control" name="medicine_image" id="image" >
                </div>
               <div class="form-group col-md-12">
                 <label for="description">Description</label>
                 <textarea class="form-control" name="description" rows="5" id="description"></textarea>
               </div>
            </form>
         </div>
         <div class="clearfix"></div>
         <div class="modal-footer">
           <button  class="btn" id="createMedicineButton">Create Medicine</button>
           <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
         </div>
       </div>

     </div>
   </div>
<!-- Create Modal -->
</body>
</html>
